import NalogClient from "./NalogClient";
import { INalogApiInitParams, INalogCancelIncomeResponse, INalogProfile, INalogReceiptIncome, IServiceIncome } from "./types";
declare class NalogApi extends NalogClient {
    constructor({ inn, password, phone }: INalogApiInitParams);
    getUserInfo(): Promise<INalogProfile>;
    addIncome(services: IServiceIncome[] | IServiceIncome, date?: Date): Promise<string>;
    cancelIncome(receiptUuid: string, comment: string): Promise<INalogCancelIncomeResponse["incomeInfo"]>;
    getApprovedIncome(receiptUuid: string, format?: "json" | "print"): Promise<INalogReceiptIncome | Blob>;
}
export default NalogApi;
