"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _NalogClient_instances, _a, _NalogClient_instance, _NalogClient_apiUrl, _NalogClient_fetchParams, _NalogClient_deviceInfo, _NalogClient_inn, _NalogClient_token, _NalogClient_tokenExpireIn, _NalogClient_refreshToken, _NalogClient_authPromise, _NalogClient_authPassword, _NalogClient_authPhone, _NalogClient_auth, _NalogClient_getToken;
Object.defineProperty(exports, "__esModule", { value: true });
const cross_fetch_1 = __importDefault(require("cross-fetch"));
const createDeviceId_1 = __importDefault(require("./utils/createDeviceId"));
const getPhoneConfirmationCode_1 = __importDefault(require("./utils/getPhoneConfirmationCode"));
const isExpiredToken_1 = __importDefault(require("./utils/isExpiredToken"));
const isValidPhone_1 = __importDefault(require("./utils/isValidPhone"));
class NalogClient {
    constructor({ inn, password, phone }) {
        _NalogClient_instances.add(this);
        _NalogClient_apiUrl.set(this, "https://lknpd.nalog.ru/api/v1");
        _NalogClient_fetchParams.set(this, {
            method: "POST",
            headers: {
                accept: "application/json, text/plain, */*",
                "accept-language": "ru-RU,ru;q=0.9,en-US;q=0.8,en;q=0.7",
                "content-type": "application/json",
            },
            referrer: "https://lknpd.nalog.ru/",
            referrerPolicy: "strict-origin-when-cross-origin"
        });
        _NalogClient_deviceInfo.set(this, {
            appVersion: "1.0.0",
            sourceType: "WEB",
            sourceDeviceId: "",
            metaDetails: { userAgent: "Mozilla/5.0 (Macintosh; Intel Mac OS X 11_2_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4324.192 Safari/537.36" }
        });
        _NalogClient_inn.set(this, "");
        _NalogClient_token.set(this, "");
        _NalogClient_tokenExpireIn.set(this, "");
        _NalogClient_refreshToken.set(this, "");
        _NalogClient_authPromise.set(this, void 0);
        if (__classPrivateFieldGet(NalogClient, _a, "f", _NalogClient_instance)) {
            return __classPrivateFieldGet(NalogClient, _a, "f", _NalogClient_instance);
        }
        if (phone && !(0, isValidPhone_1.default)(phone)) {
            throw new Error("Phone number entered incorrectly. Enter by pattern 79101112222");
        }
        if (!phone && (!inn || !password)) {
            throw new Error("Login and password or phone are required for authorization");
        }
        __classPrivateFieldGet(this, _NalogClient_deviceInfo, "f").sourceDeviceId = (0, createDeviceId_1.default)();
        __classPrivateFieldSet(this, _NalogClient_authPromise, phone ? __classPrivateFieldGet(this, _NalogClient_instances, "m", _NalogClient_authPhone).call(this, phone) : __classPrivateFieldGet(this, _NalogClient_instances, "m", _NalogClient_authPassword).call(this, inn, password), "f");
        __classPrivateFieldSet(NalogClient, _a, this, "f", _NalogClient_instance);
    }
    callMethod(methodPath, data) {
        return __awaiter(this, void 0, void 0, function* () {
            const token = yield __classPrivateFieldGet(this, _NalogClient_instances, "m", _NalogClient_getToken).call(this);
            const body = data ? JSON.stringify(data) : undefined;
            const params = Object.assign(Object.assign({}, __classPrivateFieldGet(this, _NalogClient_fetchParams, "f")), { headers: Object.assign(Object.assign({}, __classPrivateFieldGet(this, _NalogClient_fetchParams, "f").headers), { authorization: `Bearer ${token}` }), method: body ? "POST" : "GET", body });
            const r = yield (0, cross_fetch_1.default)(`${__classPrivateFieldGet(this, _NalogClient_apiUrl, "f")}/${methodPath}`, params);
            return yield r.json();
        });
    }
    getInn() {
        return __awaiter(this, void 0, void 0, function* () {
            yield __classPrivateFieldGet(this, _NalogClient_authPromise, "f");
            return __classPrivateFieldGet(this, _NalogClient_inn, "f");
        });
    }
    get apiUrl() {
        return __classPrivateFieldGet(this, _NalogClient_apiUrl, "f");
    }
}
_a = NalogClient, _NalogClient_apiUrl = new WeakMap(), _NalogClient_fetchParams = new WeakMap(), _NalogClient_deviceInfo = new WeakMap(), _NalogClient_inn = new WeakMap(), _NalogClient_token = new WeakMap(), _NalogClient_tokenExpireIn = new WeakMap(), _NalogClient_refreshToken = new WeakMap(), _NalogClient_authPromise = new WeakMap(), _NalogClient_instances = new WeakSet(), _NalogClient_authPassword = function _NalogClient_authPassword(username, password) {
    return __awaiter(this, void 0, void 0, function* () {
        const body = JSON.stringify({ username, password, deviceInfo: __classPrivateFieldGet(this, _NalogClient_deviceInfo, "f") });
        const r = yield (0, cross_fetch_1.default)(`${__classPrivateFieldGet(this, _NalogClient_apiUrl, "f")}/auth/lkfl`, Object.assign(Object.assign({}, __classPrivateFieldGet(this, _NalogClient_fetchParams, "f")), { body }));
        const response = yield r.json();
        __classPrivateFieldGet(this, _NalogClient_instances, "m", _NalogClient_auth).call(this, response);
    });
}, _NalogClient_authPhone = function _NalogClient_authPhone(phone) {
    return __awaiter(this, void 0, void 0, function* () {
        const body = JSON.stringify({ phone, requireTpToBeActive: true });
        const r = yield (0, cross_fetch_1.default)(`${__classPrivateFieldGet(this, _NalogClient_apiUrl, "f")}/auth/challenge/sms/start`, Object.assign(Object.assign({}, __classPrivateFieldGet(this, _NalogClient_fetchParams, "f")), { body }));
        const { challengeToken } = yield r.json();
        const code = yield (0, getPhoneConfirmationCode_1.default)();
        const bodyVerify = JSON.stringify({ deviceInfo: __classPrivateFieldGet(this, _NalogClient_deviceInfo, "f"), challengeToken, phone, code });
        const res = yield (0, cross_fetch_1.default)(`${__classPrivateFieldGet(this, _NalogClient_apiUrl, "f")}/auth/challenge/sms/verify`, Object.assign(Object.assign({}, __classPrivateFieldGet(this, _NalogClient_fetchParams, "f")), { body: bodyVerify }));
        const response = yield res.json();
        __classPrivateFieldGet(this, _NalogClient_instances, "m", _NalogClient_auth).call(this, response);
    });
}, _NalogClient_auth = function _NalogClient_auth(response) {
    if (!response.refreshToken) {
        throw new Error(response.message || "Authorization failed");
    }
    console.log("Authorization in lknpd.nalog.ru was successful");
    __classPrivateFieldSet(this, _NalogClient_inn, response.profile.inn, "f");
    __classPrivateFieldSet(this, _NalogClient_token, response.token, "f");
    __classPrivateFieldSet(this, _NalogClient_tokenExpireIn, response.tokenExpireIn, "f");
    __classPrivateFieldSet(this, _NalogClient_refreshToken, response.refreshToken, "f");
    return response;
}, _NalogClient_getToken = function _NalogClient_getToken() {
    return __awaiter(this, void 0, void 0, function* () {
        yield __classPrivateFieldGet(this, _NalogClient_authPromise, "f");
        if (__classPrivateFieldGet(this, _NalogClient_token, "f") && !(0, isExpiredToken_1.default)(__classPrivateFieldGet(this, _NalogClient_tokenExpireIn, "f"))) {
            return __classPrivateFieldGet(this, _NalogClient_token, "f");
        }
        const body = JSON.stringify({ deviceInfo: __classPrivateFieldGet(this, _NalogClient_deviceInfo, "f"), refreshToken: __classPrivateFieldGet(this, _NalogClient_refreshToken, "f") });
        const r = yield (0, cross_fetch_1.default)(`${__classPrivateFieldGet(this, _NalogClient_apiUrl, "f")}/auth/token`, Object.assign(Object.assign({}, __classPrivateFieldGet(this, _NalogClient_fetchParams, "f")), { body }));
        const response = yield r.json();
        if (!response.token) {
            throw new Error(response.message || "Failed to refresh token");
        }
        __classPrivateFieldSet(this, _NalogClient_refreshToken, response.refreshToken || __classPrivateFieldGet(this, _NalogClient_refreshToken, "f"), "f");
        __classPrivateFieldSet(this, _NalogClient_token, response.token, "f");
        __classPrivateFieldSet(this, _NalogClient_tokenExpireIn, response.tokenExpireIn, "f");
        return __classPrivateFieldGet(this, _NalogClient_token, "f");
    });
};
_NalogClient_instance = { value: void 0 };
exports.default = NalogClient;
//# sourceMappingURL=NalogClient.js.map